{
  "schema_version": "1.4.0",
  "id": "GHSA-m9m5-cg5h-r582",
  "modified": "2023-06-13T20:01:40Z",
  "published": "2021-08-25T20:50:24Z",
  "aliases": [
    "CVE-2020-35926"
  ],
  "summary": "Improper random number generation in nanorand",
  "details": "In versions of nanorand prior to 0.5.1, RandomGen implementations for standard unsigned integers could fail to properly generate numbers, due to using bit-shifting to truncate a 64-bit number, rather than just an as conversion. This often manifested as RNGs returning nothing but 0, including the cryptographically secure ChaCha random number generator.",
  "severity": [
    {
      "type": "CVSS_V3",
      "score": "CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N"
    }
  ],
  "affected": [
    {
      "package": {
        "ecosystem": "crates.io",
        "name": "nanorand"
      },
      "ranges": [
        {
          "type": "ECOSYSTEM",
          "events": [
            {
              "introduced": "0"
            },
            {
              "fixed": "0.5.1"
            }
          ]
        }
      ]
    }
  ],
  "references": [
    {
      "type": "ADVISORY",
      "url": "https://nvd.nist.gov/vuln/detail/CVE-2020-35926"
    },
    {
      "type": "WEB",
      "url": "https://github.com/Absolucy/nanorand-rs/commit/5ba218ac29df4786b002d7d12b47fa0c04a331f2"
    },
    {
      "type": "PACKAGE",
      "url": "https://github.com/Absolucy/nanorand-rs"
    },
    {
      "type": "WEB",
      "url": "https://rustsec.org/advisories/RUSTSEC-2020-0089.html"
    },
    {
      "type": "WEB",
      "url": "https://twitter.com/aspenluxxxy/status/1336684692284772352"
    }
  ],
  "database_specific": {
    "cwe_ids": [
      "CWE-338"
    ],
    "severity": "MODERATE",
    "github_reviewed": true,
    "github_reviewed_at": "2021-08-19T18:55:41Z",
    "nvd_published_at": null
  }
}